"""
Django settings for fastplatform project.

Generated by 'django-admin startproject' using Django 3.0.2.

For more information on this file, see
https://docs.djangoproject.com/en/3.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.0/ref/settings/
"""

import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))



# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.environ.get('DJANGO_SECRET_KEY')

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = os.environ.get('DEBUG', 'TRUE').upper() == 'TRUE'

DOMAIN_NAME = os.environ.get('DOMAIN_NAME')
SESSION_COOKIE_DOMAIN = os.environ.get('SESSION_COOKIE_DOMAIN')

DJANGO_ALLOWED_HOSTS = os.environ.get('DJANGO_ALLOWED_HOSTS')

if DEBUG:
    ALLOWED_HOSTS = ['localhost.fastplatform.eu', 'host.docker.internal', DOMAIN_NAME] + DJANGO_ALLOWED_HOSTS.split(',')
else:
    ALLOWED_HOSTS = [DOMAIN_NAME] + DJANGO_ALLOWED_HOSTS.split(',')

SILENCED_SYSTEM_CHECKS = ["admin.E410"]

# Security

CSRF_COOKIE_SECURE = os.environ.get("DJANGO_CSRF_COOKIE_SECURE", "FALSE").upper() == "TRUE"

SECURE_HSTS_SECONDS = int(os.environ.get("DJANGO_SECURE_HSTS_SECONDS", 0))
if SECURE_HSTS_SECONDS > 0:
    SECURE_HSTS_INCLUDE_SUBDOMAINS = True
    SECURE_HSTS_PRELOAD = True

SECURE_REFERRER_POLICY = 'same-origin'

SESSION_COOKIE_SECURE = os.environ.get("DJANGO_SESSION_COOKIE_SECURE", "FALSE").upper() == "TRUE"

# Application definition

INSTALLED_APPS = [
    'admin_interface',
    'colorfield',
    'admin.apps.FaSTAdminConfig',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'user_sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'authentication',
    'opcyl',
    'storages',
]

if DEBUG:
    INSTALLED_APPS += ['sslserver']

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'user_sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'fastplatform.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'fastplatform.wsgi.application'


# Database
# https://docs.djangoproject.com/en/3.0/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql',
        'NAME': os.environ.get('POSTGRES_DATABASE'),
        'USER': os.environ.get('POSTGRES_USER'),
        'PASSWORD': os.environ.get('POSTGRES_PASSWORD'),
        'HOST': os.environ.get('POSTGRES_HOST'),
        'PORT': os.environ.get('POSTGRES_PORT')
    }
}


# Password validation
# https://docs.djangoproject.com/en/3.0/ref/settings/#auth-password-validators
AUTH_USER_MODEL = 'authentication.User'


AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/3.0/topics/i18n/

LANGUAGE_CODE = 'es'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.0/howto/static-files/

# STATIC_ROOT = os.environ.get('STATIC_ROOT', os.path.join(BASE_DIR, 'data', 'dev', 'static'))
STATIC_URL = os.environ.get('STATIC_URL', '/static/')

# MEDIA_ROOT = os.environ.get('MEDIA_ROOT', os.path.join(BASE_DIR, 'data', 'dev', 'media'))
MEDIA_URL = os.environ.get('MEDIA_URL', '/media/')

# Authentication

SESSION_ENGINE = 'user_sessions.backends.db'

AUTHENTICATION_REDIRECT_URL = os.environ.get('AUTHENTICATION_REDIRECT_URL')

# Op Cyl 

OP_CYL_URL = os.environ.get('OP_CYL_URL')

OP_CYL_APP_NAME = os.environ.get('OP_CYL_APP_NAME')

OP_CYL_API_KEY = os.environ.get('OP_CYL_API_KEY')

OP_CYL_CHECK_TOKEN_URL = os.environ.get('OP_CYL_CHECK_TOKEN_URL')

LOGIN_URL = '/'

LOGOUT_REDIRECT_URL = LOGIN_URL

# Messages 

MESSAGE_STORAGE = 'django.contrib.messages.storage.session.SessionStorage'